package main

import "fmt"
import "os"
import "bytes"
import "time"
import "io"
import "strings"

func wordCarousel(display []rune, pos *int, l int) string {
    buf := &bytes.Buffer{}
    
    for i := 0; i != l ;i++ {
        idx := i + *pos
        if idx >= len(display) {
            idx -= len(display)
        }
        buf.WriteRune(display[idx])
    }
    *pos++;
    if *pos >= len(display) {
        *pos = 0;
    }
    return buf.String()
}

func main() {
    buf := &bytes.Buffer{}
    _, err := io.Copy(buf, os.Stdin)
    if err != nil {
        panic(err)
    }
    display := []rune(strings.TrimSpace(buf.String()))
    fmt.Fprint(os.Stdout, "\n")
    var pos int
    displayLen := 21 
    // check if the display length is longer than the available input
    if displayLen > len(display) {
      // shorten to half the input
      displayLen = len(display) / 2
      // prevent the length from becoming zero
      if displayLen == 0 {
        displayLen = 1
      }
    }
    for {
        fmt.Fprint(os.Stdout,"\r")
        displayIteration := wordCarousel(display, &pos, displayLen)
        fmt.Fprint(os.Stdout, displayIteration)
        time.Sleep(220 * time.Millisecond)
    }
}
